/*
City of Saint Paul Open Source License

LICENSE

Copyright © 2006 City of Saint Paul, Minnesota. 

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following terms and conditions:

1.The above copyright notice and this permission notice shall be included in all copies of this Software or works derived from this Software.
2.Whenever a Recipient distributes or redistributes the Software, a copy of this agreement must be included with each copy of the Software
3.If Recipient distributes or redistributes the Software in any form other than source code, Recipient must also make the source code freely available, and must provide with each copy of the Software information on how to obtain the source code in a reasonable manner on or through a medium customarily used for software exchange
4.A Recipient may not make any representation in the Software or in any promotional, advertising or other material that may be construed as an endorsement by the City of Saint Paul of any product or service provided by Recipient, or that may seek to obtain commercial advantage by the fact of the City of Saint Paul’s participation in this Agreement.

DISCLAIMER OF WARRANTIES AND LIABILITIES; WAIVER AND INDEMNIFICATION

No Warranty:  The Software is provided “as is” without any warranty of any kind, either expressed, implied, or statutory, including, but not limited to, any warranty that the Software will conform to specifications, any implied warranties of merchantability, fitness for a particular purpose, or freedom from infringement, any warranty that the Software will be error free, or any warranty that documentation, if provided, will conform to the Software. This agreement does not, in any manner, constitute an endorsement by the City of Saint Paul or any prior recipient of any results, resulting designs, hardware, software products or any other applications resulting from use of the Software. Further, the City of Saint Paul disclaims all warranties and liabilities regarding third-party software, if present in the original Software, and distributes it “as is.”

Waiver and Indemnity:  Recipient agrees to waive any and all claims against the City of Saint Paul, its contractors and subcontractors, as well as any prior recipient.  If recipient's use of the Software results in any liabilities, demands, damages, expenses or losses arising from such use, including any damages from products based on, or resulting from, recipient's use of the Software, recipient shall indemnify and hold harmless the City of Saint Paul, it’s contractors and subcontractors, as well as any prior recipient, to the extent permitted by law. Recipient's sole remedy for any such matter shall be the immediate, unilateral termination of this agreement.

SUPPORT STATEMENT 

The Software is freely provided by the City of Saint Paul as a public service.  The recipient is herby notified that the provision and distribution of the Software should in no way be construed to mean that the City of Saint Paul is obligated to provide any level of support for the Software, now or in the future.  Support in this context shall be construed to mean providing coordination, technical assistance, responding to questions, releasing bug fixes, providing future releases, or otherwise obligating the City of Saint Paul to commit resources to maintain this Software or assist in its implementation by any person or entity.  The City of Saint Paul may, at it’s sole option, and without notice or obligation to the recipients, provide varying levels of support for the Software or terminate the agreement.  Provision of such support shall not alter the condition that the Software is provided without support as stated above.
*/

/*
 * Manages the results Tab
 */


function ResultsTab(tabName) {
	this.tabButton;
	this.tabPane;
}

function Results() {
	var Tabs = new Array();

	var resultsParent = document.createElement('div');
	var resultsTitle = document.createElement('div');
	var resultsBody = document.createElement('div');

	resultsParent.id = 'ResultsParent';

	resultsTitle.className = 'ResultsTitle';
	resultsBody.className = 'ResultsContent';
	
	resultsParent.appendChild(resultsTitle);
	resultsParent.appendChild(resultsBody);
	
	this.getResults = function() {
		return resultsParent;		
	}

	this.getTitle = function() {
		return resultsTitle;
	}

	this.getContent = function() {
		return resultsBody;
	}

	this.onClose = function() {
	}

	this.showTab = function(tabName) {
		for(var tab in Tabs) {
			Tabs[tab].tabPane.style.visibility = 'hidden';
			//Tabs[tab].tabPane.style.height = '10px';
			Tabs[tab].tabButton.className='InactiveTab';
		}
		Tabs[tabName].tabPane.style.visibility = 'visible';
		Tabs[tabName].tabButton.className = 'ActiveTab';
		//Tabs[tabName].tabPane.style.height = 'auto';
	}

	this.countTabs = function() {
		var i = 0;
		for(var t in Tabs) {
			i++;
		}
		return i;
	}	

	function getTabIndex(tabName) {
		var i = 0;
		var ret = 0;
		for(var tab in Tabs) {
			if(tab == tabName) { return i; }
			i++;
		}
		return -1;

	}

	function tabsToArray() {
		var arr = new Array();
		for(var tab in Tabs) {
			arr[arr.length] = Tabs[tab];
		}	
		return arr;
	}
	
	function getNextTab(tabName) {
		var arr = tabsToArray();
		var idx = getTabIndex(tabName);
	
		var next = idx+1;

		if(idx == -1 || arr.length == 1) { return -1; }
		if(next == arr.length) { return idx - 1; }
		return next;
	}

	function indexToTabName(idx) {
		var i = 0;
		for(var tab in Tabs) {
			if(i == idx) { return tab; }
			i++;
		}
		return -1;
	}

	this.removeTab = function(tabName) {
		if(Tabs[tabName]) {	
			resultsBody.removeChild(Tabs[tabName].tabPane);
			resultsTitle.removeChild(Tabs[tabName].tabButton);

			var nextTab = getNextTab(tabName);
			var nextTabName = indexToTabName(nextTab);
			delete Tabs[tabName];

			if(this.countTabs() == 0) {
				var parent = resultsParent.parentNode;
				parent.removeChild(resultsParent);	
				this.onClose();
			} else {
				//logDebugMessage('Results', false,'Next Tab Index: '+nextTab+' Next Tab Name: '+nextTabName);
				this.showTab(nextTabName);
			}

		}
	}

	this.addTab = function(tabName) {
		Tabs[tabName] = new ResultsTab(tabName);
		
		var myself = this;

		var tabButton = document.createElement('span');
		tabButton.className = 'ActiveTab';
		var Label = document.createElement('a');
		Label.appendChild(document.createTextNode(tabName));
		Label = document.createTextNode(tabName);
		var CloseButton = document.createElement('img');
		CloseButton.setAttribute('src', REMOVE_ICON);
		CloseButton.onclick = function() {
			myself.removeTab(tabName);
		}
	
		tabButton.appendChild(Label);
		tabButton.appendChild(CloseButton);

		tabButton.onclick = function () {
			myself.showTab(tabName);
		}

		var tabContent = document.createElement('div');
		Tabs[tabName].tabButton = tabButton;
		Tabs[tabName].tabPane = tabContent;

		resultsTitle.appendChild(tabButton);
		resultsBody.appendChild(tabContent);
		return Tabs[tabName].tabPane;
	}

	this.resetTabContent = function(tabName) {
		if(Tabs[tabName] && Tabs[tabName].tabPane) {
			var elm = Tabs[tabName].tabPane;
			resultsBody.removeChild(elm);
			Tabs[tabName].tabPane = document.createElement('div');
			resultsBody.appendChild(Tabs[tabName].tabPane);
		}
	}

	this.getResultsContent = function(tabName) {
		// If no tab, then create one
		if(!Tabs[tabName]) {
			this.addTab(tabName);
		}
		// bring the tab to the front
		this.showTab(tabName);
		// return the tab
		return Tabs[tabName].tabPane;
	}
}


